﻿// ------------------------------------------------------------------------------------
//
// CounterInput.CS                                               Ulrich Müller 31.10.09
//                                                               Aspire C# 2005 Express
// Assembly FishFaceTX.DLL : Klasse CounterInput
//
// ------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace FishFaceTX {
  public class CounterInput : DeviceBase {
    public delegate void Counter(CounterInput sender, int Value);
    public event Counter CurrentValue;

    public CounterInput(FishControl fc, Ctr devId, Cnt CounterName)
      : this(fc, false, devId, CounterName) {
    }
    public CounterInput(FishControl fc, bool WithEvents, Ctr ctrId, Cnt CounterName)
      : base(fc, WithEvents, (int)ctrId, (int)CounterName) {
      base.threadInterval = 22;
      base.deviceType = "Count";
    }

    protected override void EventLoop() {
      while (!tx.NotHalt && !tx.IsESC) {
        if (CurrentValue != null) CurrentValue(this, 
          tx.GetCounter((Ctr)base.controllerNumber, (Cnt)base.connectorNumber));
        Thread.Sleep(base.threadInterval);
      }
    }

    public void ResetCounter() {
      tx.ClearCounter((Ctr)base.controllerNumber, (Cnt)base.connectorNumber);
    }
    public override string ConnectorName {
      get {
        return ((Cnt)base.connectorNumber).ToString();
      }
    }
    public int ActualValue {
      get {
        return tx.GetCounter((Ctr)base.controllerNumber, (Cnt)base.connectorNumber);
      }
    }
    public void WaitForCount(int ICount) {
      //tx.WaitForCount((Ctr)base.controllerNumber, 
      //  (Cnt)base.connectorNumber, ICount);
    }
  }
}
