﻿// --------------------------------------------------------------------------------------
//
// MonoOutput.CS                                                   Ulrich Müller 01.11.09
//                                                                 Aspire C# 2005 Express
// Basis für Devices, die an O-Ausgänge angeschlossen sind
//       Lampen ... an M-Ausgängen gelten als einpolig angeschlossen, 
//                  wenn OutName angegeben wird
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace FishFaceTX {
  public class MonoOutput : DeviceBase {
    protected Dir stateValue;

    public MonoOutput(FishControl fc, Ctr ctrId, Out OutputName)
      : base(fc, false, (int)ctrId, (int)OutputName) {
      base.deviceType = "Out";
      this.stateValue = Dir.Off;
    }
    public override string ConnectorName {
      get {
        return ((Out)base.connectorNumber).ToString();
      }
    }
    public Dir State {
      get {
        return stateValue;
      }
    }
    protected override void EventLoop() {
      throw new Exception("The method or operation is not implemented.");
    }
    public void On() {
      this.On(512);
    }
    public void On(int power) {
      tx.SetLamp((Ctr)base.controllerNumber, (Out)base.connectorNumber, Dir.On, power);
      stateValue = Dir.On;
    }
    public void Off() {
      tx.SetLamp((Ctr)base.controllerNumber, (Out)base.connectorNumber, Dir.Off);
      stateValue = Dir.Off;
    }
    public void Switch(Dir State) {
      tx.SetLamp((Ctr)base.controllerNumber, (Out)base.connectorNumber, State);
      stateValue = State;
    }
  }
}
