﻿// --------------------------------------------------------------------------------------
//
// FishTXWindows                                                   Ulrich Müller 01.12.09
//                                                                 Aspire C# 2005 Express
// Programmrahmen (Template) für den Einsatz der Assembly FishFaceTX.DLL
// Achtung : Der COM-Name im Control txtCom muß angepasst werden.
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace FishTXWindows {
  public partial class frmMain : Form {
    FishFace tx = new FishFace();

    private void Action() {
      // --- Routine für den Modellbetrieb, kann weitere Methoden aufrufen ---
      do {
        // --- Endlosschleife, Abbruch durch Halt-Button oder ESC-Taste, 
        //                     kann gelöscht werden

      } while (!tx.Finish());
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        tx.OpenController(txtCom.Text);
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

      }
      catch (FishFaceException txe) {
        MessageBox.Show(txe.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        tx.CloseController();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      // --- Programmende nur, wenn Action nicht läuft ---
      if (cmdEnde.Text == "&HALT") tx.NotHalt = true; else this.Close();
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      // --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ------
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}